// sešteva ena nit, brez registov
__kernel void dot_product(__global const float *A,
						  __global const float *B,
						  __global float *P,
						  int size,
						  __local float *partial)
{
	int lid = get_local_id(0);
	int gid = get_global_id(0);

	partial[lid] = 0.0;
    while (gid < size)
    {
		partial[lid] += A[gid] * B[gid];
       	gid += get_global_size(0);
    }

	barrier(CLK_LOCAL_MEM_FENCE);

	if (lid == 0)
	{
		P[get_group_id(0)] = 0.0;
		for (int i = 0; i < get_local_size(0); i++)
			P[get_group_id(0)] += partial[i];
	}
}
