// sešteva ena nit,privatna spremenljivka sum
__kernel void dot_product(__global const float *A,
						  __global const float *B,
						  __global float *P,
						  int size,
						  __local float *partial)
{
	int lid = get_local_id(0);
	int gid = get_global_id(0);

	float sum = 0.0;
    while (gid < size)
    {
		sum += A[gid] * B[gid];
       	gid += get_global_size(0);
    }
	partial[lid] = sum;

	barrier(CLK_LOCAL_MEM_FENCE);

	if (lid == 0)
	{		
		sum = 0.0;
		for (int i = 0; i < get_local_size(0); i++)
			sum += partial[i];
		P[get_group_id(0)] = sum;
	}
}
