// seštevamo po drevesu, najprej oddaljene, velikost delovne skupine ni potenca 2, mahinacije z biti
__kernel void dot_product(__global const float *A,
						  __global const float *B,
						  __global float *P,
						  int size,
						  __local float *partial)
{
	int lid = get_local_id(0);
	int gid = get_global_id(0);

	float sum = 0.0;
    while (gid < size)
    {
		sum += A[gid] * B[gid];
       	gid += get_global_size(0);
    }
	partial[lid] = sum;

	barrier(CLK_LOCAL_MEM_FENCE);

	int floorPow2 = get_local_size(0);
	while (floorPow2 & (floorPow2-1))
		floorPow2 &= floorPow2-1;
	if (get_local_size(0) != floorPow2)										
	{
		if (lid >= floorPow2)
            partial[lid - floorPow2] += partial[lid];
		barrier(CLK_LOCAL_MEM_FENCE);
    }

	int idxStep;

	for (idxStep = floorPow2 >> 1; idxStep > 32; idxStep >>= 1)
	{
		if (lid < idxStep)
			partial[lid] += partial[lid+idxStep];
		barrier(CLK_LOCAL_MEM_FENCE);
	}
	for ( ; idxStep > 0; idxStep >>= 1)
	{
		if (lid < idxStep)
			partial[lid] += partial[lid+idxStep];
	}

	if (lid == 0)
	{		
		P[get_group_id(0)] = partial[0];
	}
}
