#include <stdio.h>
#include <stdlib.h>
#include <CL/cl.h>

// nsc-fp[001,008]

int main(void)
{
	cl_int 		ret;
	char		buffer[10240];
	size_t		buf_len;
	cl_uint		buf_uint;
	cl_ulong	buf_ulong;
	size_t		buf_size_t;

	// max. platforms, ptr to platforms, num. of platforms
    cl_uint num_platforms;
    cl_int clStatus = clGetPlatformIDs(0, NULL, &num_platforms);
    cl_platform_id *platforms = (cl_platform_id *)malloc(sizeof(cl_platform_id)*num_platforms);
    clStatus = clGetPlatformIDs(num_platforms, platforms, NULL);

	for (int i = 0; i<(int)num_platforms; i++)
	{
		printf("platform[%d]:\n", i);
		ret = clGetPlatformInfo(platforms[i], CL_PLATFORM_NAME, 0, NULL, &buf_len);
		// ptr to platform, feature, length - 0, location - NULL, ptr to string length
		char *buf = (char *)malloc(sizeof(char*)*(buf_len + 1));
		ret = clGetPlatformInfo(platforms[i], CL_PLATFORM_NAME, buf_len, buf, NULL);
		// ptr to platform, feature, length - buflen, location - buf, exact length
		printf("  %s\n", buf);
		free(buf);

		cl_uint num_devices;
    	clStatus = clGetDeviceIDs(platforms[i], CL_DEVICE_TYPE_ALL, 0, NULL, &num_devices);
    	cl_device_id *devices = (cl_device_id *)malloc(sizeof(cl_device_id)*num_devices);
    	clStatus = clGetDeviceIDs(platforms[i], CL_DEVICE_TYPE_ALL, num_devices, devices, NULL);

		// selected platform, device type, max. devices, ptr to devices, num. of devices
		for (int j = 0; j<(int)num_devices; j++)
		{
			printf("  device[%d]:\n", j);
			clGetDeviceInfo(devices[j], CL_DEVICE_NAME, sizeof(buffer), buffer, NULL);
			printf("    DEVICE_NAME = %s\n", buffer);
			clGetDeviceInfo(devices[j], CL_DEVICE_VENDOR, sizeof(buffer), buffer, NULL);
			printf("    DEVICE_VENDOR = %s\n", buffer);
			clGetDeviceInfo(devices[j], CL_DEVICE_VERSION, sizeof(buffer), buffer, NULL);
			printf("    DEVICE_VERSION = %s\n", buffer);
			clGetDeviceInfo(devices[j], CL_DRIVER_VERSION, sizeof(buffer), buffer, NULL);
			printf("    DRIVER_VERSION = %s\n", buffer);
			clGetDeviceInfo(devices[j], CL_DEVICE_MAX_COMPUTE_UNITS, sizeof(buf_uint), &buf_uint, NULL);
			printf("    DEVICE_MAX_COMPUTE_UNITS = %u\n", (unsigned int)buf_uint);
			clGetDeviceInfo(devices[j], CL_DEVICE_MAX_CLOCK_FREQUENCY, sizeof(buf_uint), &buf_uint, NULL);
			printf("    DEVICE_MAX_CLOCK_FREQUENCY = %u\n", (unsigned int)buf_uint);
			clGetDeviceInfo(devices[j], CL_DEVICE_GLOBAL_MEM_SIZE, sizeof(buf_ulong), &buf_ulong, NULL);
			printf("    DEVICE_GLOBAL_MEM_SIZE = %llu\n", (unsigned long long)buf_ulong);
			clGetDeviceInfo(devices[j], CL_DEVICE_MAX_WORK_GROUP_SIZE, sizeof(buf_size_t), &buf_size_t, NULL);
			printf("    DEVICE_MAX_WORK_GROUP_SIZE = %u\n", (size_t)buf_size_t);
			clGetDeviceInfo(devices[j], CL_DEVICE_MAX_WORK_ITEM_DIMENSIONS, sizeof(buf_uint), &buf_uint, NULL);
			printf("    DEVICE_MAX_WORK_ITEM_DIMENSIONS = %u\n", (unsigned int)buf_uint);
			clGetDeviceInfo(devices[j], CL_DEVICE_NATIVE_VECTOR_WIDTH_FLOAT, sizeof(buf_uint), &buf_uint, NULL);
			printf("    DEVICE_NATIVE_VECTOR_WIDTH_FLOAT = %u\n", (unsigned int)buf_uint);
			clGetDeviceInfo(devices[j], CL_DEVICE_ADDRESS_BITS, sizeof(buf_uint), &buf_uint, NULL);
			printf("    CL_DEVICE_ADDRESS_BITS = %u\n", (unsigned int)buf_uint);
			clGetDeviceInfo(devices[j], CL_KERNEL_PREFERRED_WORK_GROUP_SIZE_MULTIPLE, sizeof(buf_uint), &buf_uint, NULL);
			printf("    CL_KERNEL_PREFERRED_WORK_GROUP_SIZE_MULTIPLE = %u\n", (unsigned int)buf_uint);
		}

		free(devices);
	}

	free(platforms);

	return 0;
}
